<?php

function atvd2to3($idnum)
{
   include('../_cfg/config.php');
   $sql_atvd='select * from atvd2 where idnum2="'.$idnum.'"';
   $res_atvd=msql_query($sql_atvd,$link_vcrx);
   
}



function tfle_totatvd($docu,$idnum)
{
   include('../_cfg/config.php');
   
   $sql_plan='select * from plan1 where idnum1="'.$idnum.'"';   
   $res_plan=msql_query($sql_plan,$link_vcrx);
   
   $xnumero=msql_result($res_plan,0,'numero');
   
   $sql_atvd ='select *, sum(tcant)as stcant, sum(total)as stotal from atvd12 ';
   $sql_atvd.=' where status!="O"';
   $sql_atvd.=' and (numerpla="'.$xnumero.'")';
   //   $sql_atvd.=' and substring(asub,1,4)in(select substring(asub,1,4) from plan2 where idnum2="'.$pidnum.'")';
   $sql_atvd.=' order by substring(asub,1,4),fecha,idnum1,iddet';
   $res_atvd=msql_query($sql_atvd,$link_vcrx);
   
   $totalatvd=array();
   $totalatvd[1]=msql_result($res_atvd,0,'stcant');
   $totalatvd[2]=msql_result($res_atvd,0,'stotal');
   
   return $totalatvd;
}


function tfle_getplan($docu,$idnum)
{
   include('../_cfg/config.php');
   $sql_atvd='select * from atvd12 where idnum1="'.$idnum.'"';   
   $res_atvd=msql_query($sql_atvd,$link_vcrx);
   
   while($aso_atvd=msql_fetch_assoc($res_atvd))
   {
      $iddet=$aso_atvd['iddet'];
      $fecha=$aso_atvd['fecha'];
      $enti2=$aso_atvd['enti2'];
      $asub=$aso_atvd['asub'];
      
      $sql_plan ='select * from plan12 ';
      $sql_plan.='where status not in("X","O")';
      $sql_plan.=' and enti like "'.substr($enti2,0,10).'%" ';
      $sql_plan.=' and asub like "'.substr($asub,0,4).'%"';
      $sql_plan.=' and fecha<="'.$fecha.'" ';
      $res_plan=msql_query($sql_plan,$link_vcrx);
//       echo '<br>';
//       echo '<br>';
//       echo '<br>'.$sql_plan.'-'.msql_error();
      
      if(msql_num_rows($res_plan)==0)
      {
         $sql_plan ='select * from plan12 ';
         $sql_plan.='where status not in("X","O")';
         $sql_plan.=' and enti like "'.substr($enti2,0,10).'%" ';
         $sql_plan.=' and asub like "'.substr($asub,0,4).'%"';
         $res_plan=msql_query($sql_plan,$link_vcrx);
//       echo '<br>'.$sql_plan.'-'.msql_error();
      }
      
      if(msql_num_rows($res_plan)==0)
      {
         $sql_plan ='select * from plan12 ';
         $sql_plan.='where status not in("X","O")';
         $sql_plan.=' and enti like "'.substr($enti2,0,10).'%" ';
         $res_plan=msql_query($sql_plan,$link_vcrx);
//       echo '<br>'.$sql_plan.'-'.msql_error();
      }
      
      $empr1=msql_result($res_plan,0,'empr1');
      $documpla=msql_result($res_plan,0,'docu');
      $ptoempla=msql_result($res_plan,0,'ptoe');
      $numerpla=msql_result($res_plan,0,'numero');
      $valorpla=msql_result($res_plan,0,'valorpla');

      
      $sql_updt='update atvd2 set ';
//       $sql_updt.='zsub2= ';
      $sql_updt.='empr2="'.$empr1.'", ';
//       $sql_updt.='docum="'.$documpla.'", ';
//       $sql_updt.='ptoem="'.$ptoempla.'", ';
//       $sql_updt.='numer="'.$numerpla.'", ';
      $sql_updt.='numerpla="'.$numerpla.'", ';
      $sql_updt.='valorpla="'.$valorpla.'" ';
      $sql_updt.='where idnum2="'.$idnum.'" ';
      $sql_updt.=' and iddet="'.$iddet.'" ';
      $res_updt=msql_query($sql_updt,$link_vcrx);
//       echo '<br>'.$sql_updt.'-'.msql_error();
      
   }
   
   
}


function tfle_getplanall($fecha1,$fecha2='')
{
   if(empty($fecha1)){return;}
   if(empty($fecha2)){$fecha2=$fecha1;}
   $fecha2=date('Y-m-t', strtotime($fecha2));
   
   include('../_cfg/config.php');
   $sql_atvd ='select * ';
   $sql_atvd.=' from atvd1 ';
   $sql_atvd.=' where status!="O" and status!="X" ';
//    $sql_atvd.=' and enti2 like "'.$empl.'%" ';
   $sql_atvd.=' and fecha>="'.$fecha1.'" ';
   $sql_atvd.=' and fecha<="'.$fecha2.'" ';
   $sql_atvd.=' order by idnum1 ';
   $res_atvd=msql_query($sql_atvd,$link_vcrx);
   
   while($aso_atvd=msql_fetch_assoc($res_atvd))
   {
      tfle_getplan($aso_atvd['docu'],$aso_atvd['idnum1']);
   }
   
   
}


function tfle_costatvd($fecha1,$fecha2='',$empl='')
{
   if(empty($fecha1)){return;}
   if(empty($fecha2)){$fecha2=$fecha1;}
   $fecha1=date('Y-m-01',strtotime($fecha1)); 
//    $fecha2=date('Y-m-t', strtotime($fecha2));
   $fecha2=date('Y-m-t', strtotime($fecha1));
//    $fecha1=date('Y-m-01',strtotime ('-1 month')); 
   
     
     
   include('../_cfg/config.php');
   
   $sql_atvd ='select distinct enti, substring(fecha,1,7) as fames  ';
   $sql_atvd.=' from atvd1 ';
   $sql_atvd.=' where status!="O" ';
   if(!empty($empl))
   {$sql_atvd.=' and enti like "'.substr($empl,0,10).'%" ';}
   $sql_atvd.=' and fecha>="'.$fecha1.'" ';
   $sql_atvd.=' and fecha<="'.$fecha2.'" ';
   $sql_atvd.=' order by enti,fames ';
   $res_atvd=msql_query($sql_atvd,$link_vcrx);
     
//    echo '<msgalert>';  
//       echo ' \n ' .'*/*/*/*/*'.$sql_atvd.msql_error();
//    echo '</msgalert>';  
     
   
   while($aso_atvd=msql_fetch_assoc($res_atvd))
   {
      $xenti=$aso_atvd['enti'];
      $xfecha1=$aso_atvd['fames'].'-01';
      $xfecha2=$xfecha1;
      $xfecha2=date('Y-m-t', strtotime($xfecha2));
   
      $xcoste=tfle_nomiempl($xenti,$xfecha1);
      
      $sql_csub ='select * from susa12 ';
      $sql_csub.='where enti2 like "'.substr($xenti,0,10).'%" and fecha2<="'.$xfecha2.'" and csub!="" and csub is not null ';
      $sql_csub.='order by fecha2 desc limit 1';
      $res_csub=msql_query($sql_csub,$link_vcrx);
      $xcsube=@msql_result($res_csub,0,'csub');

      if(empty($xcsube))
      {
         $xcsube='GENE-GENE';
         if(substr($xenti,0,10)=='0913765145'){$xcsube='EMPL-TFL';}
         if(substr($xenti,0,10)=='0926509985'){$xcsube='EMPL-SCI';}
      }
      
      $sql_updt ='update atvd1,atvd2 set ';
      $sql_updt.=' csub1="'.$xcsube.'",';
//       $sql_updt.=' empr2="'.$xemprc.'",';
      $sql_updt.=' puni="'.$xcoste.'" ';
      $sql_updt.=' where idnum1=idnum2 ';
      $sql_updt.=' and enti like "'.$xenti.'%" ';
      $sql_updt.=' and fecha>="'.$xfecha1.'" ';
      $sql_updt.=' and fecha<="'.$xfecha2.'" ';
      $res_updt=msql_query($sql_updt,$link_vcrx);
      
//    echo '<msgalert>';  
//       echo ' \n ' .'*/*/*/*/*'.$sql_updt.msql_error();
//    echo '</msgalert>';  
      
   }
   
   echo '<msgalert>';  
      echo ' RECALCULO DESDE '.$xfecha1.' HASTA '.$xfecha2.'===> OK ';
   echo '</msgalert>';  
   
   
}


function tfle_costatvd3($fecha1,$fecha2='',$empl='')
{
   if(empty($fecha1)){return;}
   if(empty($fecha2)){$fecha2=$fecha1;}
   $fecha1=date('Y-m-01',strtotime($fecha1)); 
   $fecha2=date('Y-m-t', strtotime($fecha1));
   
   include('../_cfg/config.php');
   
   $sql_dele='delete from atvd3 where idnum2 in(select idnum1 from atvd1 where fecha between "'.$fecha1.'" and "'.$fecha2.'")';
   $res_dele=msql_query($sql_dele,$link_vcrx);
   
   $sql_atvd ='select * ';
   $sql_atvd.=' from atvd12 ';
   $sql_atvd.=' where status!="O" ';
   $sql_atvd.=' and fecha>="'.$fecha1.'" ';
   $sql_atvd.=' and fecha<="'.$fecha2.'" ';
   $sql_atvd.=' and cant*puni!=0 ';
   $sql_atvd.=' order by enti,fecha,asub ';
   $res_atvd=msql_query($sql_atvd,$link_vcrx);
   
   $enti_last='';
   while($aso_atvd=msql_fetch_assoc($res_atvd))
   {
      $xenti=substr($aso_atvd['enti'],0,10);
      if($xenti!=$enti_last)
      {
         $xcoste=tfle_nomiempl($xenti,$fecha1,'3');
      
         $sql_csub ='select * from susa12 ';
         $sql_csub.='where enti2 like "'.substr($xenti,0,10).'%" and fecha2<="'.$xfecha2.'" and csub!="" and csub is not null ';
         $sql_csub.='order by fecha2 desc limit 1';
         $res_csub=msql_query($sql_csub,$link_vcrx);
         $xcsube=@msql_result($res_csub,0,'csub');

         if(empty($xcsube))
         {
            $xcsube='GENE-GENE';
            if(substr($xenti,0,10)=='0913765145'){$xcsube='EMPL-TFL';}
            if(substr($xenti,0,10)=='0926509985'){$xcsube='EMPL-SCI';}
         }

      }
         
      $enti_last=$xenti;

      foreach($xcoste as $clave=>$valor)
      {
//          if($valor!=0)
         {
              
         $sql_inse='insert into atvd3(idnum2,iddet,nvdd)value("'.$aso_atvd['idnum1'].'","'.$aso_atvd['iddet'].'","'.$clave.'")';
         $res_inse=msql_query($sql_inse,$link_vcrx);
         
//    echo '<msgalert>';
//    echo '*/*/*/  '.$sql_inse.msql_error();
//    echo '</msgalert>';
         
         $sql_updt='update atvd3 set ';
//          $sql_updt.='enti="'.$aso_atvd['enti'].'",';
         $sql_updt.='asub="'.$aso_atvd['asub'].'",';
         $sql_updt.='cant="'.$aso_atvd['cant'].'",';
         $sql_updt.='enti2="'.$aso_atvd['enti2'].'",';
         $sql_updt.='numer="'.$aso_atvd['numer'].'",';
         $sql_updt.='empr2="'.$aso_atvd['empr2'].'",';
         $sql_updt.='valorpla="'.$aso_atvd['valorpla'].'",';
         $sql_updt.='numerpla="'.$aso_atvd['numerpla'].'",';
         $sql_updt.='detalle="'.$aso_atvd['detalle'].'",';
         $sql_updt.='puni="'.$valor.'" ';
         $sql_updt.='where idnum2="'.$aso_atvd['idnum1'].'" and iddet="'.$aso_atvd['iddet'].'" and nvdd="'.$clave.'"';
         $res_updt=msql_query($sql_updt,$link_vcrx);
//    echo '<msgalert>';
//    echo '*/*/*/  '.$sql_updt.msql_error();
//    echo '</msgalert>';
         }
         
      }
      
   }
   

   $sql_dele='delete from atvd3 where puni=0 or puni is null';
   $res_dele=msql_query($sql_dele,$link_vcrx);
   
   echo '<msgalert>';  
      echo ' DISTRIBUCION DESDE '.$fecha1.' HASTA '.$fecha2.'===> OK ';
   echo '</msgalert>';  
   
   
}



function tfle_nomiempl($empl,$fecha='',$deta=0)
{
   if(empty($empl)){return 0;}
   if(empty($fecha)){$fecha=date('Y-01-01');}
   
   include('../_cfg/config.php');
   
   $nomiempl=0;
   $empl=substr($empl,0,10);

   $fecha1=date('Y-m-01', strtotime($fecha));
   $fecha2=date('Y-m-t', strtotime($fecha));
  
   $horasxdia=8;
   $horasxmes=$horasxdia*20; //160
  
    $xanio=date('Y',strtotime($fecha1));
    $xmes=date('m',strtotime($fecha1));
    $xaniomes=date('Ym',strtotime($fecha1));

    if($cfg_empr=='tfle' and $xanio=='2020' )
    {
      if($xmes=='01'){$horasxmes=$horasxdia*23;}
      if($xmes=='02'){$horasxmes=$horasxdia*20;}
      if($xmes=='03'){$horasxmes=$horasxdia*22;}
      if($xmes=='04'){$horasxmes=$horasxdia*22;}
      if($xmes=='05'){$horasxmes=$horasxdia*21;}
      if($xmes=='06'){$horasxmes=$horasxdia*22;}
      if($xmes=='07'){$horasxmes=$horasxdia*23;}
      if($xmes=='08'){$horasxmes=$horasxdia*21;}
      if($xmes=='09'){$horasxmes=$horasxdia*22;}
      if($xmes=='10'){$horasxmes=$horasxdia*22;}
      if($xmes=='11'){$horasxmes=$horasxdia*21;}
      if($xmes=='12'){$horasxmes=$horasxdia*23;}
    }

    if($cfg_empr=='tfle' and $xanio=='2021' )
    {
      if($xmes=='01'){$horasxmes=$horasxdia*21;}
      if($xmes=='02'){$horasxmes=$horasxdia*20;}
      if($xmes=='03'){$horasxmes=$horasxdia*21;}
      if($xmes=='04'){$horasxmes=$horasxdia*22;}
      if($xmes=='05'){$horasxmes=$horasxdia*21;}
      if($xmes=='06'){$horasxmes=$horasxdia*22;}
      if($xmes=='07'){$horasxmes=$horasxdia*22;}
      if($xmes=='08'){$horasxmes=$horasxdia*22;}
      if($xmes=='09'){$horasxmes=$horasxdia*22;}
      if($xmes=='10'){$horasxmes=$horasxdia*21;}
      if($xmes=='11'){$horasxmes=$horasxdia*22;}
      if($xmes=='12'){$horasxmes=$horasxdia*23;}
    }

     
   //////////////
     // FACTURAS
     {
   $sql_comp ='select docu,numero,fecha,enti,status, sum(cant*puni) as factempl from comp12 ';
   $sql_comp.=' where enti like "'.substr($empl,0,10).'%" and status!="O" and status!="X" ';
   $sql_comp.=' group by substring(fecha,1,7) ';
   $sql_comp.=' order by fecha desc ';
   $sql_comp.=' limit 1';
   
   $res_comp=msql_query($sql_comp,$link_vcrx);
   $factempl=@msql_result($res_comp,0,'factempl');
   
   //////////////
   if(mb_stristr('0926509985',$empl))
   {
      $de13=$factempl/12;
      $sbu_actual =get_sbu($fecha);
      $de14=$sbu_actual/12;
      $vaca=$factempl/24;
      $factempl=$factempl +$de13 +$de14 +$vaca;
   }

     //carlos muñoz
   if(mb_stristr('0919660647',$empl) and $fecha>='2020-11-01')
   {$factempl=0;}
     }
     
     
     
   //////////////
   if($deta==0)
   {
        
   $sql_nomi ='select ';
   $sql_nomi.='docu,numero,fecha,enti,enti2,nvdd,nvdd_descri,status,';
   $sql_nomi.='sum(abs(cant)*abs(puni)) as costo1 ';
   $sql_nomi.=' from nomi12 ';
   $sql_nomi.=' where status!="O" ';
   $sql_nomi.=' and nvdd_descri not like "APORTE PERSONAL%" ';
   $sql_nomi.=' and enti2 like "'.$empl.'%" ';
   $sql_nomi.=' and fecha>="'.$fecha1.'" ';
   $sql_nomi.=' and fecha<="'.$fecha2.'" ';
   $res_nomi=msql_query($sql_nomi,$link_vcrx);
   $nomiempl=msql_result($res_nomi,0,'costo1');

//    //////////////
//      // FACTURAS
//      {
//    $sql_comp ='select docu,numero,fecha,enti,status, sum(cant*puni) as factempl from comp12 ';
//    $sql_comp.=' where enti like "'.substr($empl,0,10).'%" and status!="O" and status!="X" ';
//    $sql_comp.=' group by substring(fecha,1,7) ';
//    $sql_comp.=' order by fecha desc ';
//    $sql_comp.=' limit 1';
   
//    $res_comp=msql_query($sql_comp,$link_vcrx);
//    $factempl=@msql_result($res_comp,0,'factempl');
   
//    //////////////
//    if(mb_stristr('0926509985',$empl))
//    {
//       $de13=$factempl/12;
//       $sbu_actual =get_sbu($fecha);
//       $de14=$sbu_actual/12;
//       $vaca=$factempl/24;
//       $factempl=$factempl +$de13 +$de14 +$vaca;
//    }

//      //carlos muñoz
//    if(mb_stristr('0919660647',$empl) and $fecha>='2020-11-01')
//    {$factempl=0;}
//      }
  
//    $costempl=($nomiempl+$factempl)/$horasxmes;
   $costempl=((int)$nomiempl+(int)$factempl)/(int)$horasxmes;
   }

   //////////////
   if($deta==3)
   {
//       $sql_nomi ='select *, (abs(cant)*abs(puni)) as costo1 ';
      $sql_nomi ='select  ';
      $sql_nomi.='docu,numero,fecha,enti,enti2,nvdd,nvdd_descri,status,';
      $sql_nomi.='(abs(cant)*abs(puni)) as costo1 ';
      $sql_nomi.=' from nomi12 ';
      $sql_nomi.=' where status!="O" ';
      $sql_nomi.=' and nvdd_descri not like "APORTE PERSONAL%" ';
      $sql_nomi.=' and enti2 like "'.$empl.'%" ';
      $sql_nomi.=' and fecha>="'.$fecha1.'" ';
      $sql_nomi.=' and fecha<="'.$fecha2.'" ';
      $res_nomi=msql_query($sql_nomi,$link_vcrx);
      $costempl=array();
      while($aso_nomi=msql_fetch_assoc($res_nomi))
      {
         $xnvdd=$aso_nomi['nvdd'];
         $xcost=$aso_nomi['costo1'];
         $costempl[$xnvdd]=$xcost/$horasxmes;
      }
      
     // FACTURAS
//         {
//       $sql_comp ='select *, sum(cant*puni) as factempl from comp12 ';
//       $sql_comp.=' where enti like "'.substr($empl,0,10).'%" and status!="O" and status!="X" ';
//       $sql_comp.=' group by substring(fecha,1,7) ';
//       $sql_comp.=' order by fecha desc ';
//       $sql_comp.=' limit 1';

//       $res_comp=msql_query($sql_comp,$link_vcrx);
//       $factempl=@msql_result($res_comp,0,'factempl');

//       //////////////
//       if(mb_stristr('0926509985',$empl))
//       {
//          $de13=$factempl/12;
//          $sbu_actual =get_sbu($fecha);
//          $de14=$sbu_actual/12;
//          $vaca=$factempl/24;
//          $factempl=$factempl +$de13 +$de14 +$vaca;
//       }

//      //carlos muñoz
//         if(mb_stristr('0919660647',$empl) and $fecha>='2020-11-01')
//         {$factempl=0;}
//         }

        $costempl['FACTURA']=$factempl/$horasxmes;
      
   }
   
   return $costempl;
   
   
}



?>